
#include <stdio.h>
#include <stdlib.h>

#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif
#include "trans.h"
#include "fptN20.h"

typedef char *STRING;


int noOfSkip = 0;

int topK = 10;

int noOfTrans = 11;
int noOfItem;

int noOfBucket = 4;

int m = 800;
int bucketSize = 200;

int curBucketNo = 2;

int noOfSlot = 7;

double epsilon;

int memoryUsage;

int **noOfEntry;

FILE *debugFilePtr;
FILE *countFilePtr;




extern int N;
extern int expectedK;
extern int numItem;
extern int numTrans;
extern float decreaseRate;
extern char dataFile[250];
extern char treeFile[50];
extern char outFile[50];
extern int threshold;
extern int oldThreshold;

void topStream_input(char *configFile)
{
 FILE *fp;
 float thresholdDecimal;
 float floatNo;

 if ((fp = fopen(configFile, "r")) == NULL) {
        printf("Can't open config. file, %s.\n", configFile);
        exit(1);
 }

 fscanf(fp, "%d %d %f %d %d %f", &N, &expectedK, &thresholdDecimal, &numItem, &numTrans, &decreaseRate);
 fscanf(fp, "%s %s %s", dataFile, treeFile, outFile);

 noOfItem = numItem;
 noOfTrans = numTrans;
 topK = N;

 fscanf(fp, "%d %d %d", &noOfBucket, &bucketSize, &curBucketNo);
 fscanf(fp, "%f", &floatNo);

 epsilon = (double) floatNo;

 fclose(fp);
/*
 printf("N = %d\n", N);
 printf("expectedK = %d\n", expectedK);
 printf("thresholdDecimal = %f (dummy)\n", thresholdDecimal);
 printf("numItem = %d\n", numItem);
 printf("numTrans = %d\n", numTrans);
 printf("decreaseRate = %f\n", decreaseRate);
 printf("dataFile = %s\n", dataFile);
 printf("treeFile = %s\n", treeFile);
 printf("outFile = %s\n\n", outFile);
*/
 threshold = (int) (thresholdDecimal * numTrans);
 //printf("threshold = %d (dummy)\n", threshold);

 oldThreshold = numTrans;

 if (N > numItem) {
	printf("N > numItem\n");
	exit(1);
 }	
 
 return;
}


int main5()
{
	int *noOfTopK;

	int i, j, k;

	entryPtr *itemset;
	char *configFile = "configSample.txt";

	topStream_input(configFile);

	noOfTopK = (int *) malloc(sizeof(int)*expectedK);

	

	for (i = 0; i < 100;i ++)
	{
		printf(" No. %d\n", i);
		//entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK)
		itemset = processBOMO(configFile, 0, 8, 10, expectedK, noOfTopK);

		for (j = 0; j < expectedK; j++)
		{
			for (k = 0; k < noOfTopK[j]; k++)
			{
				free(itemset[j][k].item);
			}
			free(itemset[j]);
		}
		free(itemset);
	}
}

int main()
{
#ifndef _WIN32
 float  userTime, sysTime;
 struct rusage myTime1, myTime2;
#endif

	entryOutPtr *result;

	char *configFilename = "configSample.txt";

	char *debugFilename = "debug.txt";
	char *countFilename = "count.txt";

	//int noOfTrans = 12;
	//int noOfItem = 5;
	//int noOfBucket = 2;
	//int bucketSize = 4;
	//int curBucketNo = 2;
	//int topK = 2;

	int *returnK;

	double *theta;
	int i;

	debugFilePtr = (FILE *) fopen(debugFilename, "w");
	countFilePtr = (FILE *) fopen(countFilename, "w");

	topStream_input(configFilename);

	theta = (double *) malloc(sizeof(double)*expectedK);
	for (i = 0; i < expectedK; i++)
	{
		theta[i] = 1.0;
	}

	returnK = (int *) malloc(sizeof(int)*expectedK);
	memset(returnK, 0, sizeof(int)*expectedK);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
#endif

	printf("Processing data...\n");
	//entryOutPtr processData(char *filename, int noOfTrans, int noOfItem, int noOfBucket, int bucketSize, int currBucketNo, int topK, int *returnK);
	result = processData(configFilename, noOfTrans, noOfItem, noOfBucket, bucketSize, curBucketNo, topK, expectedK, theta, returnK);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);
#endif

	//void printTopOutput(FILE *filePtr, entryOutPtr output, int noOfOut)
	printTopOutput(debugFilePtr, result, returnK, expectedK);

#ifndef _WIN32
 /* output running time ----------------------------*/
 printf("build tree time:\n");
 fprintf(debugFilePtr, "build tree time:\n");
 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);
 fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
 fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif


	fclose(debugFilePtr);
	fclose(countFilePtr);
}

int main2()
{
	STRING dataFilename = "configSample.txt";

	transPtr *data;

	//noOfEntry = (int *) malloc(sizeof(int)*noOfBucket);
	//memset(noOfEntry, 0, sizeof(int)*noOfBucket);

	data = readData(dataFilename, noOfTrans);

	return 0;
}

